from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Int, String, Boolean

Fix_In_Frame_Stop_Codon_Genes_Py_V0_1_0 = CommandToolBuilder(tool="fix_in_frame_stop_codon_genes.py", base_command=["fix_in_frame_stop_codon_genes.py"], inputs=[ToolInput(tag="in_genome", input_type=File(optional=True), prefix="--genome", doc=InputDocumentation(doc="genome sequence file (FASTA format)")), ToolInput(tag="in_gtf", input_type=File(optional=True), prefix="--gtf", doc=InputDocumentation(doc="GTF input file")), ToolInput(tag="in_gff_three", input_type=Int(optional=True), prefix="--gff3", doc=InputDocumentation(doc="GFF3 input file")), ToolInput(tag="in_bad_genes", input_type=File(optional=True), prefix="--badGenes", doc=InputDocumentation(doc="File with list of transcript IDs of genes with in-\nframe stop codons")), ToolInput(tag="in_hints_file", input_type=File(optional=True), prefix="--hintsfile", doc=InputDocumentation(doc="File with hints in gff format used for (re-)predicting\ngenes with AUGUSTUS")), ToolInput(tag="in_out", input_type=File(optional=True), prefix="--out", doc=InputDocumentation(doc="Name stem of the output file; will be extended with\n.gtf or .gff3 depending on the input format.")), ToolInput(tag="in_species", input_type=String(optional=True), prefix="--species", doc=InputDocumentation(doc="Set the species to be used for running AUGUSTUS")), ToolInput(tag="in_extrinsic_cfgfile", input_type=File(optional=True), prefix="--extrinsicCfgFile", doc=InputDocumentation(doc="Set extrinsic config file for AUGUSTUS")), ToolInput(tag="in_soft_masking", input_type=String(optional=True), prefix="--softmasking", doc=InputDocumentation(doc="Choose 'on' if the genome file is softmasked")), ToolInput(tag="in_utr", input_type=String(optional=True), prefix="--UTR", doc=InputDocumentation(doc="Predict the untranslated regions in addition to the\ncoding sequence. If UTR=on was used in the original\nAUGUSTUS run, use '--UTR on' here, otherwise not")), ToolInput(tag="in_print_utr", input_type=String(optional=True), prefix="--print_utr", doc=InputDocumentation(doc="Choose 'on' if --print-utr=on was used in the original\nAUGUSTUS run")), ToolInput(tag="in_additional_aug_args", input_type=File(optional=True), prefix="--additional_aug_args", doc=InputDocumentation(doc="One or several command line arguments to be passed to\nAUGUSTUS (which can not be given with another specific\ncommand line argument here). The list of arguments has\nto be given in quotes. If several arguments are given,\nthey have to be separated by whitespace, i.e. '--\nfirst_arg=sth --second_arg=sth'. If only one argument\nis given, the argument still has to contain a\nwhitespace, i.e. '--first_arg=sth '. Beware: Do not\nchoose --alternatives-from-evidence=true because mea\ncan not use this. Also do not set --exonnames (this\nparameter will be set automatically depending on the\ninput gtf/gff3 file).")), ToolInput(tag="in_augustus_config_path", input_type=File(optional=True), prefix="--augustus_config_path", doc=InputDocumentation(doc="Set path to the config directory of AUGUSTUS. If not\ngiven, will try to set augustus_config_path to\nenvironment variable AUGUSTUS_CONFIG_PATH. If this\ndoes not work, will try to set augustus_config_path to\naugustus_scripts_path/../config/. The commandline\nargument --AUGUSTUS_CONFIG_PATH has higher priority\nthan the environment variable with the same name.")), ToolInput(tag="in_augustus_bin_path", input_type=File(optional=True), prefix="--augustus_bin_path", doc=InputDocumentation(doc="Set path to the AUGUSTUS directory that contains\naugustus binary. If not given, will try to locate the\npath with which(augustus)")), ToolInput(tag="in_augustus_scripts_path", input_type=File(optional=True), prefix="--augustus_scripts_path", doc=InputDocumentation(doc="Set path to the AUGUSTUS scripts directory. If not\ngiven, will try to locate the path with\nwhich(gtf2gff.pl). If this does not work, will try to\nset the path relative to the augustus_bin_path\n(augustus_bin_path/../scripts/).")), ToolInput(tag="in_no_cleanup", input_type=Boolean(optional=True), prefix="--noCleanUp", doc=InputDocumentation(doc="Unless chosen, temporary files created while running\nthis script will be deleted at the end")), ToolInput(tag="in_print_format_examples", input_type=Boolean(optional=True), prefix="--print_format_examples", doc=InputDocumentation(doc="Print gtf/gff3 input format examples, do not perform\nanalysis")), ToolInput(tag="in_cdb_tools_path", input_type=File(optional=True), prefix="--cdbtools_path", doc=InputDocumentation(doc="Set path to cdbfasta/cdbyank. If not given, will try\nto locate the path with which(cdbfasta).\n"))], outputs=[], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Fix_In_Frame_Stop_Codon_Genes_Py_V0_1_0().translate("wdl", allow_empty_container=True)

